%global githash 1787867
%global gitdate 20210507

Name:           pthreadpool
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Thread pool implementation
License:        BSD
URL:            https://github.com/Maratyszcza/pthreadpool

Source0:        %{name}.tar.xz

BuildRequires:  cmake gcc-c++ fxdiv-devel

%global __cmake_in_source_build 1

%description
Portable and efficient thread pool implementation.

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files for %{name}.


%prep
%setup -q -n %{name}


%build
sed -i 's|ADD_LIBRARY(pthreadpool SHARED ${PTHREADPOOL_SRCS})|ADD_LIBRARY(pthreadpool SHARED ${PTHREADPOOL_SRCS})\nSET_TARGET_PROPERTIES(pthreadpool PROPERTIES SOVERSION 1 VERSION 1.0)|' CMakeLists.txt
# external psimd
sed -i '/TARGET fxdiv/,/ENDIF/d' CMakeLists.txt
sed -i '/TARGET_LINK_LIBRARIES(pthreadpool PRIVATE fxdiv)/d' CMakeLists.txt

mkdir build
pushd build
%cmake .. \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
       -DPTHREADPOOL_LIBRARY_TYPE="shared" \
       -DFXDIV_SOURCE_DIR="%{_incudedir}" \
       -DPTHREADPOOL_BUILD_TESTS=OFF \
       -DPTHREADPOOL_BUILD_BENCHMARKS=OFF
make %{?_smp_mflags}
popd


%install
rm -rf %{buildroot}
pushd build
make install DESTDIR=%{buildroot}
popd


%files
%license LICENSE
%doc README.md
%{_libdir}/*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/*.so


%changelog
* Fri Sep 25 2020 Cristian Balint <cristian.balint@gmail.com>
- initial build
